"use strict";

exports.__esModule = true;
exports.default = _default;

var _regexpuCore = _interopRequireDefault(require("regexpu-core"));

var regex = _interopRequireWildcard(require("@babel/helper-regex"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return {
    visitor: {
      RegExpLiteral: function RegExpLiteral(path, state) {
        var node = path.node;

        if (!regex.is(node, "u")) {
          return;
        }

        var useUnicodeFlag = state.opts.useUnicodeFlag || false;
        node.pattern = (0, _regexpuCore.default)(node.pattern, node.flags, {
          unicodePropertyEscape: true,
          useUnicodeFlag: useUnicodeFlag
        });

        if (!useUnicodeFlag) {
          regex.pullFlag(node, "u");
        }
      }
    }
  };
}